{-# OPTIONS_GHC -Wall #-}
{-# LANGUAGE GADTSyntax #-}

-- Make a game (or any simple interactive app) by replacing the
-- GameState data type below and the three functions initGameState,
-- gamePrompt, and gameStep with your own.  You should also create
-- whatever additional data types and functions you need.

module Game where
import Text.Read (readMaybe)

-- | A type to keep track of the current state of the game. Change
--   this to whatever type makes sense for your game.  You will most
--   likely want to define other types as well.
data GameState where

  -- EXAMPLE, replace the below with your own type.

  -- Number being guessed, number of guesses
  Guessing :: Int -> Int -> GameState
  Won :: GameState

-- | The initial 'GameState' value that should be used when the game
--   starts.  Takes an infinite list of randomly generated integers in
--   the range (0, 10^6) as input, which you are free to use or ignore
--   as you wish.
initGameState :: [Int] -> GameState

-- EXAMPLE, replace the below with your own implementation.
initGameState [] = Guessing 24 1
initGameState (n:_) = Guessing (n `mod` 100) 1

-- | Given the current 'GameState', decide what prompt to show when
--   asking the user to enter input.
gamePrompt :: GameState -> String

-- EXAMPLE, replace the below with your own implementation.
gamePrompt Won = "Would you like to play again (y/n)? "
gamePrompt (Guessing _ _) = "Your guess? "

-- | The main workhorse of your game: given a 'String' representing
--   the input entered by the player at a prompt, and the current
--   'GameState', return (1) a message to be printed, and (2) possibly
--   a new/updated 'GameState', or 'Nothing' if the game is over.  Of
--   course you can and should decompose this into many smaller
--   functions.
gameStep :: String -> GameState -> (String, Maybe GameState)

-- EXAMPLE, replace the below with your own implementation.
gameStep yn Won
  | yn `elem` ["y", "Y"] = ("OK, let's play!", Just (Guessing 39 1))
  | otherwise = ("Goodbye!", Nothing)
gameStep guessStr (Guessing secret numGuesses) = case readMaybe guessStr of
  Just guess
    | guess == secret -> ("You got it!  It only took you " ++ show numGuesses ++ " guesses.", Just Won)
    | guess < secret -> ("Too low.", Just (Guessing secret (numGuesses + 1)))
    | otherwise -> ("Too high.", Just (Guessing secret (numGuesses + 1)))
  Nothing -> ("Invalid input, please guess a number.", Just (Guessing secret numGuesses))
